<?
// *********************************************************************************************************************
// Trida na realizaci strankovani dlouhych seznamu
// *********************************************************************************************************************
class cstran {

// pracovni atributy
var $cpocet;
var $perpage;

// implicitni nastaveni odkazu
var $link   = '<a href="./move-#POINTER.html">[#LOW-#HIGH]</a>';
var $nolink = '<b>[#LOW-#HIGH]</b>';
var $glue = "&nbsp;&nbsp;";



// konstruktor k nastaveni konstant ------------------------------------------------------------------------------------
function cstran($cpocet, $perpage) {
  $this->cpocet = $cpocet;
  $this->perpage = $perpage;
}
// ---------------------------------------------------------------------------------------------------------------------



// odpovi na otazku, jestli je dobre zobrazovat listu se strankovanim --------------------------------------------------
function IsGoodPageBarToShow() {
  if($this->cpocet > $this->perpage) return(true); else return(false);
}
// ---------------------------------------------------------------------------------------------------------------------



// nahrazeni makra -----------------------------------------------------------------------------------------------------
function ReplaceMacros($link, $pointer, $high, $low) {
 $s = str_replace("#POINTER", $pointer, $link);
 $s = str_replace("#HIGH", $high, $s);
 $s = str_replace("#LOW", $low, $s);
 return($s);
}
// ---------------------------------------------------------------------------------------------------------------------



// otestuje korektni hodnotu pointeru a prvede pripadnou korekci -------------------------------------------------------
function TestPointer($pointer) {
  if(($this->perpage * pointer) > $this->cpocet) return(0);
  else return($pointer);
}
// ---------------------------------------------------------------------------------------------------------------------



// zobrazeni navbaru s nastavenim dle pointeru -------------------------------------------------------------------------
function PageBar($pointer) {
  $pointer = $this->TestPointer($pointer);
  $aOut = array();
  $n=0;
  while (($n*$this->perpage) < $this->cpocet) {
    $low  = $n * $this->perpage + 1;
    $high = ($n+1) * $this->perpage;
    if($high>$this->cpocet) $high = $this->cpocet;
    if($n == $pointer) {
      $aOut[] = $this->ReplaceMacros($this->nolink, $n, $high, $low);
    } else {
      $aOut[] = $this->ReplaceMacros($this->link, $n, $high, $low);
    }
    $n++;
  }
  return(implode($this->glue, $aOut));
}
// ---------------------------------------------------------------------------------------------------------------------



// Vrati true, pokud index zbozi lezi v intervalu ukazatele ------------------------------------------------------------
function IsIn($citac, $pointer) {
  $pointer = $this->TestPointer($pointer);
  $low = $pointer * $this->perpage;
  $high = $pointer * $this->perpage + $this->perpage;
  if($citac>$low && $citac<=$high) return true;
  return false;
}
// ---------------------------------------------------------------------------------------------------------------------



}
?>
