<?php




// ----------------------------------------------------------------------------------------------------


// ----------------------------------------------------------------------------------------------------

// test jedne radky v databazi s numerickym argumentem
function check_sql_oneline($data, $sqlpart) {
  if(!isset($data)) return false;
  if(!is_numeric($data)) return false;
  $sqlq = mysql_query("$sqlpart$data"); 
  if(mysql_num_rows($sqlq)!=1) return false;
  return true;
}

// ----------------------------------------------------------------------------------------------------

// test jedne radky v databazi s numerickym argumentem
function check_array_oneline($adata, $sqlpart, $pocet) {
  if(!isset($adata)) return false;
  if(!is_array($adata)) return false;
  if(!isset($pocet) || !is_numeric($pocet)) $pocet=1;
  if(count($adata)>$pocet) return;
  foreach ($adata as $id_okres) {
  	if(!is_numeric($id_okres)) return false;
  	$sqlq = mysql_query("$sqlpart$id_okres");
  	if(mysql_num_rows($sqlq)!=1) return false;
  }
  return true;
}


// ----------------------------------------------------------------------------------------------------

// otestuje, zda-li je ve vysledku dotazu mene jak minlines radku
// FALSE: pokud je jich vice jak minlines
// TRUE:  pokud je jich stejne nebo mene jak minlines
function check_sql_minlines($minlines, $sqlpart) {
  if(!isset($minlines)) return false;
  if(!is_numeric($minlines)) return false;
  $sqlq = mysql_query("$sqlpart"); 
  if( mysql_num_rows($sqlq) > $minlines ) return false;
  return true;
}

// ----------------------------------------------------------------------------------------------------

// otestuje exitenci alespon jednoho radku dotazu
// FALSE: pokud je pocet radku dotazu > 0
// TRUE:  pokud je pocet radku dotazu = 0  
function check_sql_zero($sqlpart) {
  $sqlq = mysql_query("$sqlpart"); 
  if( mysql_num_rows($sqlq) == 0 ) return true;
  return false;
}

// ----------------------------------------------------------------------------------------------------





// ---------------------------------------------------------------------------------------------------------------------
// Testy dat
// ---------------------------------------------------------------------------------------------------------------------
// intervalovy test hodnoty, bud min/max nebo presne
function check_interval($data, $min) {
  if(!isset($data)) return false;
  if(!is_numeric($data)) return false;
  if( func_num_args()==3 ) $max = func_get_arg(2); else $max = $min;
  if( !( ($data>=$min) && ($data<=$max) ) ) return false;
  return true;
}

// test nenuloveho obsahu stringu (mozno specifikovat min a max delku)
function check_string($data) {
  if(!isset($data)) return false;
  $string = stripslashes(strip_tags($data));
  if(strlen($string)==0) return false;
  if( func_num_args()==3 ) {
    if( (strlen($string)<func_get_arg(1)) || (strlen($string)>func_get_arg(2)) ) return false; 
  }  
  return true;
}

// test retezce na regex
function check_regex($data, $regex) {
  if(!isset($data)) return false;
  if(!ereg($regex, $data))  return false;
  return true;
}

// test spravne zadane emailove adresy
function check_email($data) {
  if(!isset($data)) return false;
  if(!ereg("^[_a-zA-Z0-9\.\-]+@[_a-zA-Z0-9\.\-]+\.[a-zA-Z]{2,4}$", $data))  return false; 
  return true;
}

function check_cz_termin($data) {
  if( eregi('^[0-9]{4}\-[0-9]{2}\-[0-9]{2}\ [0-9]{2}:[0-9]{2}:[0-9]{2}$', $data) ) return(true);
  return(false);
}

// ---------------------------------------------------------------------------------------------------------------------





// ---------------------------------------------------------------------------------------------------------------------
// pravy etzc
// ---------------------------------------------------------------------------------------------------------------------
// upravi string z formulare do bezpecne formy
function mrpropper($data) {
  $string = strip_tags($data);
  $string = stripslashes($string);
  $string = str_replace("'","\'",$string);
  $string = str_replace('"','\"',$string);
  return($string);  
}

// upravi string z formulare do bezpecne formy - light verze
function mrpropper_light($data) {
  $string = str_replace("'","\'",$data);
  return($string);  
}
// ---------------------------------------------------------------------------------------------------------------------





// ---------------------------------------------------------------------------------------------------------------------
// Presmeruje na danou adresu
// ---------------------------------------------------------------------------------------------------------------------
function redirect_to_url($url, $text) {
  echo '<script>window.location.href="'.$url.'";</script>';
  echo '<p align="center">'.$text.'</p>';
  echo '<p align="center">Pokud se tak nestalo, kliknte, prosm, <a href="./">ZDE</a>.</p>';  
  exit;  
 }
// ---------------------------------------------------------------------------------------------------------------------





// ---------------------------------------------------------------------------------------------------------------------
// vrati html error zpravy
// ---------------------------------------------------------------------------------------------------------------------
function printerr($zprava) {
  echo '
   <div class="error_msg">
     '.$zprava.'
   </div>';
  return(true);    
}
// ---------------------------------------------------------------------------------------------------------------------



function zerofill($cislo) {
  if($cislo<10) $out=$out.'0';
  return($out.$cislo);
}



// ---------------------------------------------------------------------------------------------------------------------
// HTML selecty
// ---------------------------------------------------------------------------------------------------------------------

// html select uzivatele
function htmlselect_users($arg){
 if (!$arg) $arg=0;
 $sql=MySql_query("SELECT CASE WHEN id_uzivatel='$arg' 
                   THEN '<option selected ' ELSE '<option ' END AS tag1,
                   id_uzivatel, prjm, jmeno 
                   FROM a_uzivatel ORDER BY prjm ASC");
 while ($zaznam=MySql_Fetch_Array($sql)) 
  $output=$output.$zaznam[tag1].'value="'.$zaznam[id_uzivatel].'">'.$zaznam[prjm].' '.$zaznam[jmeno].'</option>';
 return '<option value="nenizadano">-- vyber cloveka --</option>'.$output;
}

// html select prodejni jednotky 
function htmlselect_jednotka($arg){
 if (!$arg) $arg=0;
 $sql=MySql_query("SELECT *, CASE WHEN idj='$arg' 
                   THEN '<option selected ' ELSE '<option ' END AS tag1
                   FROM sa_jednotka ORDER BY jnazev");
 while ($zaznam=MySql_Fetch_Array($sql)) 
  $output=$output.$zaznam[tag1].'value="'.$zaznam[idj].'">'.$zaznam[jnazev].' ['.$zaznam[jednotka].']</option>';
 return '<option value="nenizadano">-- vyber jednotku --</option>'.$output;
}

// html select kategorii s podporou rekurze
function htmlselect_kategorie($arg){
  if (!$arg) $arg=0;
  if( func_num_args()==2 ) $cap = func_get_arg(1); else $cap = 'koen stromu';
  $output = $output . '<option value="0">-- '.$cap.' --</option>';
  $sql = mysql_query("SELECT lft, rgt FROM asp_problem WHERE deep=1 ORDER BY poradi ASC");
  while( $data=@Mysql_Fetch_Array($sql) ) { 
    $sql2 = mysql_query("SELECT *, CASE WHEN ids=$arg THEN '<option selected ' ELSE '<option ' END AS tag1 
                         FROM asp_problem 
                         WHERE lft BETWEEN ".$data[lft]." AND ".$data[rgt]."
                         ORDER BY lft ASC");
    while ( $zaznam=@Mysql_Fetch_Array($sql2) ) {
      $output = $output . $zaznam[tag1].'value="'.$zaznam[ids].'">'.str_repeat("&nbsp;", ($zaznam[deep]-1)*5).$zaznam[snazev].'</option>';
    }
  }  
  return $output; 
}

// ---------------------------------------------------------------------------------------------------------------------





// ---------------------------------------------------------------------------------------------------------------------
// Provede konverzi z POSTU a z db hodnoty do html tvaru
// ---------------------------------------------------------------------------------------------------------------------
function ConvertToCB($post, $db) {
  $found = false;
  if( isset($post) ) $found=true;
  if( isset($db) && ($db=='1') ) $found=true;
  if( $found ) return ('checked="true"');
}
// ---------------------------------------------------------------------------------------------------------------------





// ---------------------------------------------------------------------------------------------------------------------
// Aktualizuje tabulku pro trizeni produktu po vlozeni noveho nebo uprave kategorii
// Info: Pro kazdy produkt musi byt v tabulce tolik zaznamu, jaka je hloubka stromu.
//       Je mozne specifikovat poradi produktu pro kazdou uroven zanoreni do stromu
// ---------------------------------------------------------------------------------------------------------------------
function RenewOrderTable() {
  $hloubka = GetStromDeep();
  if(!is_numeric($hloubka)) return;
   // smazani hloubek, ktere nepotrebujeme (snizeni hloubky stromu kategorii) 
  MySql_query("DELETE FROM asp_order WHERE deep>$hloubka");
  MySql_query("DELETE FROM asp_order WHERE deep IS NULL");
   // doplneni tabulky sa_order novymi produkty, ktere v ni jeste nejsou
  for($n=1; $n<=$hloubka; $n++) {
    MySql_query("INSERT INTO asp_order(idp, deep, poradi) 
                 SELECT idp,$n,idp
                 FROM asp_zaznam 
                 WHERE (SELECT count(*) FROM asp_order WHERE (asp_order.idp=asp_zaznam.idp) AND (deep=$n) )=0");
  }
}
// ---------------------------------------------------------------------------------------------------------------------




// ---------------------------------------------------------------------------------------------------------------------
// funkce na aktualizaci stromu pro prochazeni metodou "Modified Preorder Tree Traversal Algoritmus".
// INFO: http://interval.cz/clanky/metody-ukladani-stromovych-dat-v-relacnich-databazich/
// ---------------------------------------------------------------------------------------------------------------------
function RebuildTreeMPTTA($predek, $left, $deep) {
  $right = $left+1;
  $deep++;
  $result = mysql_query('SELECT ids, snazev FROM asp_problem WHERE predek='.$predek.' ORDER BY poradi ASC');
  while ($row = mysql_fetch_array($result)) {
    $right = RebuildTreeMPTTA($row['ids'], $right, $deep);
  }
  mysql_query('UPDATE asp_problem SET lft='.$left.', rgt='.$right.', deep='.($deep-1).' WHERE ids='.$predek);
  return $right+1;
}
// ---------------------------------------------------------------------------------------------------------------------




// ---------------------------------------------------------------------------------------------------------------------
// Vrati hloubku stromu kategorii
// ---------------------------------------------------------------------------------------------------------------------
function GetStromDeep() {
  $sql=MySql_query("SELECT MAX(deep) AS maxdeep FROM asp_problem ");
  $data = @Mysql_Fetch_Array($sql);
  return ($data[maxdeep]);
}
// ---------------------------------------------------------------------------------------------------------------------





// ---------------------------------------------------------------------------------------------------------------------
// Vrati aktualni hloubku kategorie
// ---------------------------------------------------------------------------------------------------------------------
function GetActualDeep($ids) {
  $sql=MySql_query("SELECT deep FROM asp_problem WHERE ids=$ids");
  $data = @Mysql_Fetch_Array($sql);
  return ($data[deep]);
}
// ---------------------------------------------------------------------------------------------------------------------





// ---------------------------------------------------------------------------------------------------------------------
// Vrati potomky zadane kategorie a to vcetne ji samotne
// ---------------------------------------------------------------------------------------------------------------------
function GetChilds($ids) {
  if(is_numeric($ids) && ($ids!=0) ) $whr='WHERE ids='.$ids;
  $sql = mysql_query("SELECT lft, rgt, ids FROM asp_problem $whr");
  $aout = array();
  while ( $zaznam = Mysql_Fetch_Array($sql) ) {
    $aout[] = $zaznam[ids];
    $sql2 = mysql_query('SELECT ids FROM asp_problem WHERE lft BETWEEN '.$zaznam[lft].' AND '.$zaznam[rgt].' ORDER BY lft ASC');
    while ( $data=@Mysql_Fetch_Array($sql2) ) { 
      $aout[] = $data[ids]; 
    } 
  }
  return($aout);
}
// ---------------------------------------------------------------------------------------------------------------------





// ---------------------------------------------------------------------------------------------------------------------
// Vrati prvky od koene k ids
// ---------------------------------------------------------------------------------------------------------------------
function GetTheWay($ids) {
  if( !is_numeric($ids) ) return;
  $aout = array();
  $data = Mysql_Fetch_Array(mysql_query("SELECT lft, rgt FROM asp_problem WHERE ids=$ids"));
  $sql = mysql_query("SELECT ids, snazev FROM asp_problem WHERE lft<=".$data[lft]." AND rgt>=".$data[rgt]." ORDER BY lft ASC");
  while( $zaznam=@Mysql_Fetch_Array($sql) ) { 
    array_push($aout, $zaznam[snazev]);
  }
  return implode(" -> ", $aout);
}
// ---------------------------------------------------------------------------------------------------------------------




// ---------------------------------------------------------------------------------------------------------------------
// Vytvoen adres pro uloen dat produktu
// ---------------------------------------------------------------------------------------------------------------------
function MakeDirectory($dir) {
  umask(0);
  mkdir($dir);
  mkdir($dir."/foto");
  mkdir($dir."/data");
  chmod($dir, 0777);
  mkdir($dir."/foto", 0777);
  mkdir($dir."/data", 0777);
}
// ---------------------------------------------------------------------------------------------------------------------





// ---------------------------------------------------------------------------------------------------------------------
// Zapsn textov poznmky k produktu
// ---------------------------------------------------------------------------------------------------------------------
function WriteProductNotify($dir, $text) {
  $FW = fopen("$dir/product_info.txt", "w");
  fwrite($FW, "$text");
  fclose($FW);
}
// ---------------------------------------------------------------------------------------------------------------------


?>
